#include <iostream>
#include <vector>
#include <curl/curl.h>
#include "text.h"
#include "histogram.h"
#include "svg.h"
#include "procent.h"
using namespace std;
struct Input {
    vector<double> numbers;
    size_t number_count{};
    size_t bin_count{};
    size_t max_count{};
};
Input
input_data(istream& inn,bool prompt) {
    if(prompt== true)
    {
        Input in;
        cerr << "Enter number count: ";
        inn >> in.number_count;
        vector<double> numbers(in.number_count);
        in.numbers.resize(in.number_count);
        for (size_t i = 0; i < in.number_count; i++) {
            inn >> in.numbers[i];
        }
        size_t bin_count;
        cerr << "Enter bin count: ";
        inn >> in.bin_count;
        size_t max_count;
        in.max_count = 0;
        return in;
    }
    if(prompt==false)
    {
        Input in;
        inn >> in.number_count;
        vector<double> numbers(in.number_count);
        in.numbers.resize(in.number_count);
        for (size_t i = 0; i < in.number_count; i++) {
            inn >> in.numbers[i];
        }
        size_t bin_count;
        inn >> in.bin_count;
        size_t max_count;
        in.max_count = 0;
        return in;
    }
}
int main(int argc, char* argv[])
{
    if(argc>1)
    {
        cout<<argc<<endl;
        for(size_t i=0;i<argc;i++)
        {
            cout<<argv[i]<<" ";
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    auto in = input_data(cin,true);

    auto bins = make_histogram(in.numbers, in.bin_count);
    auto max_count=bins[0];
    for(size_t x : bins){
        if (x > max_count)
        {
            max_count=x;
        }
    }
    show_histogram_text(bins,in.bin_count,in.numbers,max_count);
    //show_histogram_svg(bins, max_count);
    return 0;
}
